import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { PureComponent } from 'react';
import SvgIcon from '@material-ui/core/SvgIcon';
import OpenWithLabel from './icons/OpenWithLabel';
import Open from '@material-ui/icons/Menu';
import Close from '@material-ui/icons/Close';
import { TransitionGroup, CSSTransition } from 'react-transition-group';
import { withStyles } from '@material-ui/core';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      height: '24px',
      width: '24px',
      boxSizing: 'border-box',
      '& .rsf-menu-icon-enter': {
        opacity: 0.01,
        transform: 'scale(0) rotate(45deg)'
      },
      '& .rsf-menu-icon-enter.rsf-menu-icon-enter-active': {
        opacity: 1,
        transform: 'scale(1) rotate(0deg)',
        transition: 'all 250ms ease-out'
      },
      '& .rsf-menu-icon-exit': {
        opacity: 1,
        transform: 'scale(1) rotate(0deg)'
      },
      '& .rsf-menu-icon-exit.rsf-menu-icon-exit-active': {
        opacity: 0.01,
        transform: 'scale(0) rotate(45deg)',
        transition: 'all 250ms ease-in'
      }
    },
    icon: {
      color: theme.palette.action.active,
      position: 'absolute',
      top: 0,
      left: 0
    }
  };
};
/**
 * A menu icon that animates transitions between open and closed states.
 */

var MenuIcon = (_dec = withStyles(styles, {
  name: 'RSFMenuIcon'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(MenuIcon, _PureComponent);

  function MenuIcon() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MenuIcon);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MenuIcon)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      OpenIcon: null,
      CloseIcon: null
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "cssProps", {
      classNames: 'rsf-menu-icon',
      timeout: 300
    });

    return _this;
  }

  _createClass(MenuIcon, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          open = _this$props.open,
          classes = _this$props.classes;
      var _this$state = this.state,
          OpenIcon = _this$state.OpenIcon,
          CloseIcon = _this$state.CloseIcon;
      return React.createElement("div", {
        className: classes.root
      }, React.createElement(TransitionGroup, null, !open ? React.createElement(CSSTransition, _extends({}, this.cssProps, {
        key: "open"
      }), React.createElement(SvgIcon, {
        className: classes.icon
      }, React.createElement(OpenIcon, null))) : React.createElement(CSSTransition, _extends({}, this.cssProps, {
        key: "close"
      }), React.createElement(SvgIcon, {
        className: classes.icon
      }, React.createElement(CloseIcon, null)))));
    }
  }]);

  return MenuIcon;
}(PureComponent), _defineProperty(_class2, "propTypes", {
  /**
   * Set to true when the menu is open, otherwise false
   */
  open: PropTypes.bool,

  /**
   * Set to `false` to hide the text "menu" underneath the button when the menu is closed.
   */
  label: PropTypes.bool,

  /**
   * The icon to display when the menu is closed
   */
  OpenIcon: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),

  /**
   * The icon to display when the menu is open
   */
  CloseIcon: PropTypes.oneOfType([PropTypes.string, PropTypes.func])
}), _defineProperty(_class2, "defaultProps", {
  open: false,
  label: true,
  CloseIcon: Close
}), _defineProperty(_class2, "getDerivedStateFromProps", function (props) {
  return {
    OpenIcon: props.OpenIcon || (props.label ? OpenWithLabel : Open),
    CloseIcon: props.CloseIcon
  };
}), _temp)) || _class);
export { MenuIcon as default };
//# sourceMappingURL=MenuIcon.js.map