import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _dec3, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { inject } from 'mobx-react';
import withStyles from '@material-ui/core/styles/withStyles';
import withTheme from '@material-ui/core/styles/withTheme';
import { Helmet } from "react-helmet";
import Link from '../Link';
import Typography from '@material-ui/core/Typography';
import classnames from 'classnames';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import ExpandLessIcon from '@material-ui/icons/ExpandLess';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      marginTop: theme.headerHeight,
      height: "calc(100vh - ".concat(theme.headerHeight, "px)"),
      borderTop: "1px solid ".concat(theme.palette.divider),
      backgroundColor: theme.palette.background.paper,
      boxShadow: '10px 2px 10px -5px rgba(0, 0, 0, 0.2)',
      paddingBottom: '64px',
      '& h3': {
        backgroundColor: theme.palette.background.paper
      },
      '& section[expanded] > h3': {
        color: theme.palette.secondary.contrastText,
        backgroundColor: theme.palette.secondary.main,
        borderColor: theme.palette.secondary.main
      },
      '& a': {
        color: theme.typography.body1.color
      },
      '& ~ div[class*="amphtml-sidebar-mask"]': {
        background: 'rgba(0, 0, 0, 0.5)',
        opacity: 1
      }
    },
    item: {
      padding: '12px 16px',
      borderColor: theme.palette.divider,
      borderWidth: '0 0 1px 0',
      borderStyle: 'solid',
      display: 'block',
      textDecoration: 'none'
    },
    group: {
      textTransform: 'uppercase'
    },
    toggle: {
      position: 'absolute',
      right: '18px',
      top: '10px'
    },
    expand: {
      display: 'block',
      'section[expanded] > h3 > &': {
        display: 'none'
      }
    },
    collapse: {
      display: 'none',
      'section[expanded] > h3 > &': {
        display: 'block'
      }
    }
  };
};
/**
 * An AMP-compatible menu based on amp-sidebar.
 */

var AmpMenu = (_dec = withTheme(), _dec2 = withStyles(styles, {
  name: 'RSFAmpMenu'
}), _dec3 = inject(function (_ref) {
  var app = _ref.app;
  return {
    menu: app.menu
  };
}), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpMenu, _Component);

  function AmpMenu() {
    _classCallCheck(this, AmpMenu);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpMenu).apply(this, arguments));
  }

  _createClass(AmpMenu, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          menu = _this$props.menu,
          classes = _this$props.classes,
          drawerWidth = _this$props.drawerWidth,
          rootHeader = _this$props.rootHeader,
          rootFooter = _this$props.rootFooter,
          align = _this$props.align;
      var root = menu.levels.length ? menu.levels[0] : null;
      return React.createElement(Fragment, null, React.createElement(Helmet, {
        key: "helmet"
      }, React.createElement("script", {
        async: true,
        "custom-element": "amp-sidebar",
        src: "https://cdn.ampproject.org/v0/amp-sidebar-0.1.js"
      }), React.createElement("script", {
        async: true,
        "custom-element": "amp-accordion",
        src: "https://cdn.ampproject.org/v0/amp-accordion-0.1.js"
      }), React.createElement("style", {
        "amp-custom": true
      }, "\n            #".concat(id, " {\n              width: ").concat(drawerWidth, "px;\n            }\n          "))), React.createElement("amp-sidebar", {
        key: "sidebar",
        id: id,
        class: classes.root,
        layout: "nodisplay",
        side: align
      }, rootHeader, this.renderItem(root), rootFooter));
    }
  }, {
    key: "renderItem",
    value: function renderItem(item, key) {
      if (item == null) {
        return null;
      } else if (item.items) {
        return this.renderGroup(item, key);
      } else {
        return this.renderLeaf(item, key);
      }
    }
  }, {
    key: "renderGroup",
    value: function renderGroup(item, key) {
      var _this = this;

      var _this$props2 = this.props,
          classes = _this$props2.classes,
          ExpandIcon = _this$props2.ExpandIcon,
          CollapseIcon = _this$props2.CollapseIcon,
          theme = _this$props2.theme;
      ExpandIcon = ExpandIcon || theme.ExpandIcon || ExpandMoreIcon;
      CollapseIcon = CollapseIcon || theme.CollapseIcon || ExpandLessIcon;
      var section = React.createElement("section", {
        key: key
      }, item.text && React.createElement(Typography, {
        variant: "body1",
        component: "h3",
        className: classnames(classes.item, classes.group)
      }, item.text, React.createElement(CollapseIcon, {
        className: classnames(classes.toggle, classes.collapse)
      }), React.createElement(ExpandIcon, {
        className: classnames(classes.toggle, classes.expand)
      })), React.createElement("div", null, item.items.map(function (item, i) {
        return _this.renderItem(item, i);
      })));

      if (item.root) {
        return section;
      } else {
        return React.createElement("amp-accordion", {
          key: key,
          "disable-session-states": true
        }, section);
      }
    }
  }, {
    key: "renderLeaf",
    value: function renderLeaf(item, key) {
      return React.createElement(Link, {
        key: key,
        className: this.props.classes.item,
        to: item.url
      }, item.text);
    }
  }]);

  return AmpMenu;
}(Component), _defineProperty(_class2, "defaultProps", {
  id: 'moov_menu'
}), _temp)) || _class) || _class) || _class);
export { AmpMenu as default };
//# sourceMappingURL=AmpMenu.js.map